/*
 * みおぽん(オープンソース版) v1.0.1
 *
 * Copyright(c) 2013 Internet Initiative Japan Inc.
 * All Rights Reserved.
 *
 * This software is released under the BSD License, see LICENSE.txt.
 *
 */

  var arrayServiceCode = [];
  var arrayTelno = [];
  var arrayIccid = [];
  var arrayCouponSwitch = [];
  var arrayCouponSwitchCurrent = [];
  var arrayIndex = [];
  var token = "";
  var account = "";
  var pageFlag = 0;
  var couponStatusCache = "";
  var taphold = false;
  var cacheInterval = 600;
  var timeStamp = 0;
  var apiEndPoint = "https://api.iijmio.jp/mobile/d/";
  var errMsg = "";
  var errTitle = "エラー";
  var isApp = false;
  var isIos = false;
  var doOnce = true;
  var eula = false;
  var transition = "none";
  var changedItemCount = 0;
  var locked = false;
  var versionNumber = '1';
  var versionString = 'v' + versionNumber;
  var suffix= versionString + "/";
  var state = 'dummy';
  var authEndPoint = apiEndPoint + versionString + "/authorization/";

  var clientId = 'IIJmioDeveloper';              // デベロッパID
  var redirectUrl = 'jp.ad.iij.openmiopon://cb'; // リダイレクトURI
  var isDebug = true;

  // コンソールログ出力
  var log = (function() {
    if (isDebug) {
      return console.log.bind(console);
    }
    return function(){};
  })();

  // センタリング拡張
  $.fn.center = function(params) {
    return this.each(function() {
      var $self = jQuery(this);
      var width = $self.width();
      var height = $self.height();
      var paddingTop = parseInt($self.css("padding-top"));
      var paddingBottom = parseInt($self.css("padding-bottom"));
      var borderTop = parseInt($self.css("border-top-width"));
      var borderBottom = parseInt($self.css("border-bottom-width"));
      var mediaBorder = (borderTop+borderBottom)/2;
      var mediaPadding = (paddingTop+paddingBottom)/2;
      var positionType = $self.parent().css("position");
      var halfHeight = ((height/2)*(-1))-mediaPadding-mediaBorder;
      var cssProp = {
        position: 'absolute'
      };
      cssProp.height = height;
      cssProp.top = '50%';
      cssProp.marginTop = halfHeight;
      cssProp.width = width;
      cssProp.left = 0;
      if(positionType == 'static') {
        $self.parent().css("position","relative");
      }
      $self.css(cssProp);
    });
  };

  //
  // ネイティブとのI/F
  //
  // ネイティブアプリとして動作する時はisApp=true
  // Webアプリとして動作する時はisApp=false
  //
  var external = {

    getToken : function() {
      log("external.getToken");
      return window.localStorage['token'];
    },

    setToken : function(arg) {
      log("external.setToken");
      window.localStorage['token'] = arg;
      return;
    },

    getCouponStatus : function() {
      log("external.getCouponStatus");
      return window.localStorage['couponStatus'];
    },

    setCouponStatus : function(arg) {
      log("external.setCouponStatus");
      window.localStorage['couponStatus'] = arg;
      return;
    },

    showDialogDefault : function(title, msg) {

      // ローディング・メッセージを非表示
      $.mobile.hidePageLoadingMsg();

      // ロック解除
      setLock(false);

//      if (isApp) {
//
//        // ネイティブ側のメソッドを呼び出す
//        if (isIos) {
//          var content = $.ajax({
//            type : 'GET',
//            url : "app://showdialog/" + title + "&" + msg,
//            async : false,
//            cache : false,
//            dataType : 'text',
//          });
//
//          return;
//        }
//
//        // 表示を少し遅らせる
//          setTimeout(function(){
//          // ダイアログを表示
//          app.showDialog(title, msg);
//          }, 200);
//
//      } else {

        // エラー画面を表示
        errTitle = title;
        errMsg = msg;

        $.mobile.changePage("#errorDialog", {
          transition : 'none',
          role : 'dialog'
        });

//      }
      return;
    },

    showDialog : function(title, msg) {

      // ローディング・メッセージを非表示
      $.mobile.hidePageLoadingMsg();

      // ロック解除
      setLock(false);

      // エラー画面を表示
      errTitle = title;
      errMsg = msg;

      $.mobile.changePage("#errorDialogWorkAround", {
        transition : 'none',
        role : 'dialog'
      });
      return;
    },

    showToast : function(arg) {

//      if (isApp) {
//        // ネイティブ側のメソッドを呼び出す
//        if (isIos) {
//          var content = $.ajax({
//            type : 'GET',
//            url : "app://showdialog/" + arg,
//            async : false,
//            cache : false,
//            dataType : 'text',
//          });
//
//          return;
//        }
//
//        app.showToast(arg);
//      } else {
        alert(arg);
//      }
      return;
    },

    setLock : function(arg) {
      if (isApp) {
        // ネイティブ側のメソッドを呼び出す
        if (isIos) {
          return;
        }
        //app.setLock(arg);
      }
      return;
    },

    invalidateView : function() {
      if (isApp) {
        // ネイティブ側のメソッドを呼び出す
        if (isIos) {
          return;
        } else {
          app.invalidateView();
        }
      }
      return;
    },
    
    // Android2系だとリダイレクトで標準ブラウザ開かないので
    openDefaultBrowser : function(arg) {
      log("external.openDefaultBrowser");
      if (isApp) {
        // ネイティブ側のメソッドを呼び出す
        if (isIos) {
          return;
        } else {
          app.openDefaultBrowser(arg);
        }
      }
      return;
    },

    getState : function() {
      log("external.getState");
      return window.localStorage['state'];
    },

    setState : function(arg) {
      log("external.setState");
      window.localStorage['state'] = arg;
      return;
    }
  };

  // アプリとして動作する時はhostnameは空
  if (window.location.hostname == "") {
    isApp = true;
  }

  if (navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/iPad/i)) {
    isIos = true;
  }

  if (isIos) {
    // iOSならtransitionを設定
    transition = "slide";
  }

  log("hostname=" + window.location.hostname + " isApp=" + isApp
      + " isIos=" + isIos + " transition=" + transition);

  // ハッシュフラグメントからパラメータを得る
  function getQueryStringParam(url, param) {
    var values = url.split('&');
    for (var i = 0; i < values.length; i++) {
      var valuePair = values[i].split('=');
      if (valuePair[0] == param) {
        return valuePair[1];
      }
    }
    return "";
  }

  // トークン取得
  function formatTelno(telno) {
    return telno.substring(0, 3) + '-' + telno.substring(3, 7) + '-'
        + telno.substring(7, 12);
  }

  function isAscii(str) {
   return /^[\x00-\x7F]*$/.test(str);
  }

  // 認可エンドポイントからのコールバックを処理する
  function callbackFromAuth(uri) {

    log("callbackFromAuth: called uri=" + uri);
  
    var params = uri.split('#');

    // リダイレクトURIと一致するかどうかチェック
    if ((params.length > 1) && (params[0] == redirectUrl)) {

      // アクセストークンとstateを取得
      var accessToken = getQueryStringParam(params[1], 'access_token');
      var receivedState = getQueryStringParam(params[1], 'state');

      log("callbackFromAuth: access_token: " + accessToken);
      log("callbackFromAuth: state: " + state);
      log("callbackFromAuth: receivedState: " + receivedState);

      // CSRF対策でstateをチェックする
      if ((accessToken != "") && (state == receivedState)) {

        // トークン更新
        token = accessToken;

        // 端末にも格納する
        external.setToken(token);

        // クーポン情報取得
        getCouponStatus(false);

      }

    }

  }
  
  // クーポン情報取得
  function getCouponStatus(useCache) {

    var request = {};

    // ロック中ならretする
    if (locked) {
      log("getCouponStatus was locked");
      return;
    }
    setLock(true);

    log("getCouponStatus calling, useCache=" + useCache);

    var urlGetCouponStatus = apiEndPoint + versionString + "/coupon/";

    // ローディング・メッセージを表示
    $.mobile.loadingMessage = "最新の情報を取得しています";
    $.mobile.showPageLoadingMsg();

    // 表示枠を隠す
    $("#inner-content").hide();

    // li要素を削除
    $("#telnoList li").remove();
    $('#update span[class^="ui-li-count"]').remove();

    // arrayをクリアする
    arrayServiceCode.length = 0;
    arrayTelno.length = 0;
    arrayCouponSwitch.length = 0;
    arrayCouponSwitchCurrent.length = 0;
    arrayIndex.length = 0;

    // クーポン情報キャッシュがあれば使う
    if (useCache && (couponStatusCache != null) && (couponStatusCache != "") && (couponStatusCache != "undefined")) {

      log("couponStatusCache exists!");

      var data = JSON.parse(couponStatusCache);

      // バージョンチェック＆タイムスタンプがあれば評価する
      if ((data.version != null) && (data.version == versionNumber) && (data.timestamp != null)) {

        // 現在時刻を取得する
        var nowTime = parseInt((new Date)/1000);

        log("nowtime=" + nowTime + " data.timestamp=" + data.timestamp + " version=" + data.version);

        // キャッシュが有効期限内なら使う
        if ((nowTime - data.timestamp) < cacheInterval) {

          // クーポン情報キャッシュを使うのは最初の一回のみ
          //couponStatusCache = "";

          // メインページを表示
          showMainPage(data);

          return;

        }
      }
    }

    // クーポン取得
    $.ajax({
      url : urlGetCouponStatus,
      type : 'GET',
      contentType : 'application/json',
      data : request,
      dataType : 'json',
      beforeSend : function(xhr) {
        xhr.setRequestHeader("X-IIJmio-Authorization", token);
        xhr.setRequestHeader("X-IIJmio-Developer", clientId);
      },
      success : getCouponStatusResultHandler(useCache),
      timeout : 30000,
      //async : false,
      crossDomain : true,
      cache : false
    }).fail(function(jqXHR, textStatus, errorThrown) {

      log("getCouponStatus jqXHR.status:" + jqXHR.status);
      log("getCouponStatus textStatus:" + textStatus);
      log("getCouponStatus responseText:" + jqXHR.responseText);

      if (jqXHR.status == 500) { // 500エラー
        // エラー画面を表示
        external.showDialog("通信エラー",
          "エラーが発生しました。サポートにお知らせください。");
      } else if (jqXHR.status == 503) { // メンテナンス
        // エラー画面を表示
        external.showDialog("サーバメンテナンス中",
          "時間を空けて再度お試しください。");
      } else if (jqXHR.status == 403) { // トークン無効
        // エラー画面を表示
        // 再認証要求画面を表示
        token = "";
        external.setToken(token);
        external.showDialog("トークンの有効期限切れ",
          "アクセストークンの有効期限が切れました。再認証してください");
      } else if (jqXHR.status == 429) { // リクエスト出し過ぎ
        // エラー画面を表示
        external.showDialog("リクエスト回数超過",
          "時間を空けて再度お試しください。");
      } else {
        external.showDialog("通信エラー",
          "情報を取得できません。ネットワーク接続が利用可能かご確認ください。");
      }
    });

  }

  // getCouponStatusコールバック
  function getCouponStatusResultHandler(paramUseCache) {

    var useCache = paramUseCache;

    return function (data, textStatus, xhr) {

      log("getCouponStatusResult success json=" + JSON.stringify(data)
        + " httpStatus=" + xhr.status);

      // クーポン情報キャッシュを更新する
      var nowTime = parseInt((new Date)/1000);
      data.timestamp = nowTime;
      data.version = versionNumber;

      external.setCouponStatus(JSON.stringify(data));
      couponStatusCache = JSON.stringify(data);
      log("update couponStatusCache");

      // パケットログ取得
      getPacketLog(useCache, data);
    };
  }


  // パケットログ取得
  function getPacketLog(useCache, couponStatusResult) {

    var request = {};

    log("getPacketLog calling, useCache=" + useCache);

    var urlGetPacketLog = apiEndPoint + versionString + "/log/packet/";

    // パケットログ取得
    $.ajax({
      url : urlGetPacketLog,
      type : 'GET',
      contentType : 'application/json',
      data : request,
      dataType : 'json',
      beforeSend : function(xhr) {
        xhr.setRequestHeader("X-IIJmio-Authorization", token);
        xhr.setRequestHeader("X-IIJmio-Developer", clientId);
      },
      success : getPacketLogResultHandler(couponStatusResult),
      timeout : 30000,
      //async : false,
      crossDomain : true,
      cache : false
    }).fail(function(jqXHR, textStatus, errorThrown) {

      log("getPacketLog textStatus:" + textStatus);
      log("getPacketLog responseText:" + jqXHR.responseText);

      if (jqXHR.status == 500) { // 500エラー
        // エラー画面を表示
        external.showDialog("通信エラー",
          "エラーが発生しました。サポートにお知らせください。");
      } else if (jqXHR.status == 503) { // メンテナンス
        // エラー画面を表示
        external.showDialog("サーバメンテナンス中",
          "時間を空けて再度お試しください。");
      } else if (jqXHR.status == 403) { // トークン無効
        // エラー画面を表示
        // 再認証要求画面を表示
        token = "";
        external.setToken(token);
        external.showDialog("トークンの有効期限切れ",
          "アクセストークンの有効期限が切れました。再認証してください");
      } else if (jqXHR.status == 429) { // リクエスト出し過ぎ
        // エラー画面を表示
        external.showDialog("リクエスト回数超過",
          "時間を空けて再度お試しください。");
      } else {
        external.showDialog("通信エラー",
          "情報を取得できません。ネットワーク接続が利用可能かご確認ください。");
      }
    });

  }
  

  // getPacketLogコールバック
  function getPacketLogResultHandler(paramCouponStatusResult) {

    var couponStatusResult = paramCouponStatusResult;

    return function (data, textStatus, xhr) {

      log("getPacketLogResult success json=" + JSON.stringify(data)
        + " httpStatus=" + xhr.status);

      // hdoをキーにしたハッシュに格納する
      var packetLogHash = {};
      for (var i = 0 ; i < data.packetLogInfo.length ; i++) {
        var packetLogInfo = data.packetLogInfo[i];
        for (var j = 0 ; j < packetLogInfo.hdoInfo.length ; j++) {
          var hdoInfo = packetLogInfo.hdoInfo[j];
          packetLogHash[hdoInfo.hdoServiceCode] = hdoInfo.packetLog;
        }
      }
      log("packetLogHash=" + JSON.stringify(packetLogHash));

      // couponStatusResultにぶら下げる
      for (var i = 0 ; i < couponStatusResult.couponInfo.length ; i++) {
        var couponInfo = couponStatusResult.couponInfo[i];
        for (var j = 0 ; j < couponInfo.hdoInfo.length ; j++) {
          var hdoInfo = couponInfo.hdoInfo[j];
          if (hdoInfo.hdoServiceCode in packetLogHash) {
            hdoInfo.packetLog = packetLogHash[hdoInfo.hdoServiceCode];
          }
        }
      }

      // クーポン情報キャッシュを更新する
      external.setCouponStatus(JSON.stringify(couponStatusResult));
      couponStatusCache = JSON.stringify(couponStatusResult);

      log("couponStatusResult=" + JSON.stringify(couponStatusResult));

      // メインページを表示
      showMainPage(couponStatusResult);
    };
  }



  // メインページを表示
  function showMainPage(data) {

    // 返却されたタイムスタンプをメモリに格納する
    timeStamp = data.timestamp;

    // 変更数カウンタをクリア
    $('#update span[class^="ui-li-count"]').remove();
    //$("#update").trigger("create");
    changedItemCount = 0;

    // liを作る
    createListItem(data);

    // liにスタイルを適用
    $("#telnoList").listview("refresh");
    $("#telnoList").trigger("create");

    // スイッチを再配置する
    for ( var i = 0, len = arrayTelno.length ; i < len; i++) {
      $(".block" + i).tile();
      $("#couponSwitchBlock" + i).center();
    }

    // ローディング・メッセージを非表示
    $.mobile.hidePageLoadingMsg();

    // ロック解除
    setLock(false);

  }

  // ON/OFFスイッチを表示する
  function createListItem(data) {

    var selected = " selected=\"selected\"";
    var on;
    var off;
    var n = 0;
    var liCount = 0;
    var fontsize = "";

    if (!data.couponInfo) {
      return;
    }

    for (var i = 0, len = data.couponInfo.length ; i < len ; i++) {
      var couponInfo = data.couponInfo[i];

      // li作る
      var divider = $("<li data-role='list-divider' data-theme='a'>");
      var divCollapsible = $("<div data-role='collapsible' data-inset='false' data-collapsed-icon='arrow-r' data-expanded-icon='arrow-d' data-theme='a' data-mini='true'>");

      // hを作る
      var h3 = $("<h3>");
      var divGrid = $("<div class='ui-grid-a'>");
      var divCaption = $("<div class='ui-block-a divider-caption'>");
      divCaption.append(couponInfo.hddServiceCode + '　'); // 高さを揃えるためダミーの全角を入れてみる
      var divCouponSum = $("<div class='ui-block-b divider-couponsum'>");
      divGrid.append(divCaption);

      // pを作る
      var detailP = $("<p class='divider-detail" + fontsize + "'>");
      var detailGrid = $("<div class='ui-grid-a'>");
      var captionStringType1 = 'バンドルクーポン';
      var captionStringType0 = '追加クーポン';
      var str;
      var couponSum = 0;

      var arrayCoupon = [];
      var arrayBundle = [];
      var arrayTopup = [];

      for (var c = 0 ; c < couponInfo.coupon.length ; c++) {
        var coupon = couponInfo.coupon[c];
        if (coupon.type == 'bundle') {
          arrayBundle.push(coupon);
        } else {
          arrayTopup.push(coupon);
        }
      }
      arrayBundle.reverse();
      arrayTopup.reverse();
      arrayCoupon = arrayBundle.concat(arrayTopup);
      
      for (var c = 0 ; c < arrayCoupon.length ; c++) {
        var coupon = arrayCoupon[c];

        var divCaption = $("<div class='ui-block-a divider-detailcaption'>");
        if (coupon.type == 'bundle') {
          str = captionStringType1;
        } else {
          str = captionStringType0;
        }
        divCaption.append(str + ' (' + coupon.expire.substr(0,4) + '年' + coupon.expire.substr(4,2) + '月迄)');

        var divValue = $("<div class='ui-block-b divider-detailvalue'>");
        divValue.append('　' + coupon.volume + "MB");
        couponSum += coupon.volume;

        detailGrid.append(divCaption);
        detailGrid.append(divValue);

      }
    
    
      detailP.append(detailGrid);

      // h3とpをappend
      divCouponSum.append("総残量 " + couponSum + "MB");
      divGrid.append(divCouponSum);
      h3.append(divGrid);
      divCollapsible.append(h3);
      divCollapsible.append(detailP);

      divider.append(divCollapsible);
      liCount++;

      $("#telnoList").append(divider);

      // 回線情報
      for (var j = 0, len2 = couponInfo.hdoInfo.length ; j < len2 ; j++) {

        log("telNo: "
          + couponInfo.hdoInfo[j].number
          + ", couponUse:"
          + couponInfo.hdoInfo[j].couponUse);

        if (couponInfo.hdoInfo[j].couponUse) {
          on = selected;
          off = "";
        } else {
          on = "";
          off = selected;
        }

        // li作る
        var li = $("<li class='li-lineinfo'>");
        if (j == 0) {
          li = $("<li class='li-lineinfo li-lineinfo-first-child'>");
        }
        var line = $("<li data-role='list-divider' data-theme='a'>");
        var divCollapsible = $("<div data-role='collapsible' data-inset='false' data-collapsed-icon='none' data-expanded-icon='none' data-theme='a' data-mini='true'>");

        // hを作る
        var h3 = $("<h3>");
        var divGrid = $("<div class='ui-grid-a li-lineinfo-grid'>");

        var divTelNo = $("<div class='ui-block-a label-block'>");

        // 同じ番号のblock-aとblock-bの高さを揃える
        divTelNo.addClass('block' + n);

        var labelTelno = formatTelno(couponInfo.hdoInfo[j].number);
        var labelCaption = '';

        // SMSフラグ
        var labelSms = '';
        if (couponInfo.hdoInfo[j].sms == true) {
          labelSms = '(SMS)';
        }

        var spanCaption = $("<span id='caption" + n + "' class='labelCaption'>").text(labelCaption);
        var spanTelNo = $("<span id='telNo" + n + "' class='labelTelno'>").text(labelTelno);
        var spanSms = $("<span class='labelSms'>").html(labelSms);
        var spanIccId = $("<span class='labelIccid'>").text(couponInfo.hdoInfo[j].iccid);
        var icon = '<img src="mail.png" class="icon-collapsible">';
        var spanIcon = "<span class='ui-icon ui-icon-arrow-r' id='iconUsage" + n + "' style='display:inline-block;vertical-align:-.15em;margin-right:.35em;'></span>";

        divTelNo.append(spanCaption);
        spanIccId.append(spanSms);
        spanTelNo.prepend(spanIcon);
        divTelNo.append(spanTelNo);
        divTelNo.append(spanIccId);

        divGrid.append(divTelNo);

        var divSwitch = $("<div class='ui-block-b ui-li-aside label-block'>");

        // 同じ番号のblock-aとblock-bの高さを揃える
        divSwitch.addClass('block' + n);

        // スイッチを含むブロックに番号を振る
        var div2Switch = $("<div id='couponSwitchBlock" + n + "' class='coupon-switch-block'>");

        var select = $("<select name='couponSwitch" + n + "' id='couponSwitch" + n + "' data-role='slider'>");
        select.append($("<option value='0'" + off + ">").text("OFF"));
        select.append($("<option value='1'" + on + ">").text("ON"));

        div2Switch.append(select);
        divSwitch.append(div2Switch);
        divGrid.append(divSwitch);

        h3.append(divGrid);

        var usageGrid = $("<div class='ui-grid-b usage" + fontsize + "' id='usage" + n + "'>").hide();
        var divDate = $("<div class='ui-block-a usage-detailcaption'>");
        divDate.append('利用日');
        var divValueHigh = $("<div class='ui-block-b usage-detailvalue'>");
        divValueHigh.append('　ON時');
        var divValueLow = $("<div class='ui-block-c usage-detailvalue'>");
        divValueLow.append('　OFF時');
        usageGrid.append(divDate);
        usageGrid.append(divValueHigh);
        usageGrid.append(divValueLow);

        var totalHigh = 0;
        var totalLow = 0;

        var packetLog = couponInfo.hdoInfo[j].packetLog;
        var packetLogLength = couponInfo.hdoInfo[j].packetLog.length;
        var lenc = 0;

        if (packetLog != null) {
          lenc = couponInfo.hdoInfo[j].packetLog.length;

          // usageを作る
          if (lenc > 4) {
            lenc = 4;
          }

        } else {

          var divDate = $("<div class='ui-block-a usage-detailcaption'>");
          divDate.append('システムエラー：時間をあけてお試しください');
          var divValueHigh = $("<div class='ui-block-b usage-detailvalue'>");
          divValueHigh.append('');
          var divValueLow = $("<div class='ui-block-c usage-detailvalue'>");
          divValueLow.append('');
          usageGrid.append(divDate);
          usageGrid.append(divValueHigh);
          usageGrid.append(divValueLow);

        }

        // 当日を含む4日分
        for (var c = 0; c < lenc ; c++) {
          var usageDetail = couponInfo.hdoInfo[j].packetLog[packetLogLength - 1 - c];

          totalHigh += parseInt(usageDetail.high);
          totalLow += parseInt(usageDetail.low);

          var divDate = $("<div class='ui-block-a usage-detailcaption'>");
          divDate.append(usageDetail.date.substr(0,4) + '年' + usageDetail.date.substr(4,2) + '月' + usageDetail.date.substr(6,2) + '日');
          var divValueHigh = $("<div class='ui-block-b usage-detailvalue'>");
          divValueHigh.append('　' + usageDetail.withCoupon + "MB");
          var divValueLow = $("<div class='ui-block-c usage-detailvalue'>");
          divValueLow.append('　' + usageDetail.withoutCoupon + "MB");
          usageGrid.append(divDate);
          usageGrid.append(divValueHigh);
          usageGrid.append(divValueLow);

        }

        // 備考欄
        if (couponInfo.hdoInfo[j].regulation) {

          var spanRegulation = $("<span class='usage-regulation-text'>");
          spanRegulation.text('OFF時 通信規制中');

          var divDate = $("<div class='ui-block-a usage-detailcaption regulation-block-a'>");
          var divValueHigh = $("<div class='ui-block-b usage-detailvalue regulation-block-b'>");
          var divValueLow = $("<div class='ui-block-c usage-detailvalue regulation-block-c'>");
          divValueLow.append(spanRegulation);
          usageGrid.append(divDate);
          usageGrid.append(divValueHigh);
          usageGrid.append(divValueLow);

        }

        li.append(divGrid);
        li.append(usageGrid);

        $("#telnoList").append(li);

        arrayServiceCode[n]      = couponInfo.hdoInfo[j].hdoServiceCode;
        arrayTelno[n]            = couponInfo.hdoInfo[j].number;
        if (couponInfo.hdoInfo[j].couponUse) {
          arrayCouponSwitch[n] = 1;
        } else {
          arrayCouponSwitch[n] = 0;
        }
        arrayCouponSwitchCurrent[n] = arrayCouponSwitch[n];
        arrayIndex[liCount] = n;
        n++;
        liCount++;

      }

    }

    $("#inner-content").show();

  }

  // クーポンON/OFF更新
  function setCouponStatus() {

    // ロック中ならretする
    if (locked) {
      log("setCouponStatus was locked");
      return;
    }
    setLock(true);

    var jsondata = {};
    var couponInfoHash = {};
    var couponInfoArray = [];
    var hdoInfoArray = [];
    var modified = false;

    // putするjsonデータをつくる
    for ( var i = 0, len = arrayTelno.length ; i < len ; i++) {

      var value = $("#couponSwitch" + i).val();
      var couponUse;

      if (value == 1) {
        couponUse = true;
      } else {
        couponUse = false;
      }

      var hdoInfo = {
        hdoServiceCode : arrayServiceCode[i],
        couponUse : couponUse
      };
      hdoInfoArray.push(hdoInfo);
    }

    couponInfoHash.hdoInfo = hdoInfoArray;
    couponInfoArray.push(couponInfoHash);
    jsondata.couponInfo = couponInfoArray;
    log(JSON.stringify(jsondata));

    var urlSetCouponStatus = apiEndPoint + versionString + "/coupon/";

    // ローディング・メッセージを表示
    $.mobile.loadingMessage = "ON/OFF変更を適用しています";
    $.mobile.showPageLoadingMsg();

    $.ajax({
      url : urlSetCouponStatus,
      type : 'PUT',
      contentType : 'application/json',
      data : JSON.stringify(jsondata),
      dataType : 'json',
      beforeSend : function(xhr) {
        xhr.setRequestHeader("X-IIJmio-Authorization", token);
        xhr.setRequestHeader("X-IIJmio-Developer", clientId);
        // xhr.setRequestHeader("If-Modified-Since", "Thu, 01 Jun 1970 00:00:00 GMT");
      },
      success : setCouponStatusResultHandler,
      timeout : 30000,
      //async : false,
      crossDomain : true,
      cache : false
    }).fail(function(jqXHR, textStatus, errorThrown) {

      log("setCouponStatus textStatus:" + textStatus);
      log("setCouponStatus responseText:" + jqXHR.responseText);

      if (jqXHR.status == 500) { // 500エラー
        // エラー画面を表示
        external.showDialog("通信エラー",
          "エラーが発生しました。サポートにお知らせください。");
      } else if (jqXHR.status == 503) { // メンテナンス
        // エラー画面を表示
        external.showDialog("サーバメンテナンス中",
          "時間を空けて再度お試しください。");
      } else if (jqXHR.status == 403) { // トークン無効
        // エラー画面を表示
        // 再認証要求画面を表示
        token = "";
        external.setToken(token);
        external.showDialog("トークンの有効期限切れ",
          "アクセストークンの有効期限が切れました。再認証してください");
      } else if (jqXHR.status == 429) { // リクエスト出し過ぎ
        // エラー画面を表示
        external.showDialog("ON/OFF変更回数超過",
          "1分以上時間を空けてから再度お試しください。");
      } else if (jqXHR.status == 400) { // パラメータエラー
        // エラー画面を表示
        external.showDialog("不正なリクエスト",
          "不正なリクエストです。");
      } else {
        external.showDialog("通信エラー",
          "情報を取得できません。ネットワーク接続が利用可能かご確認ください。");
      }

    });

  }

  // setCouponStatusのコールバック
  function setCouponStatusResultHandler(data, textStatus, xhr) {

    log("setCouponStatus success json=" + JSON.stringify(data)
        + " httpStatus=" + xhr.status);

    // クーポン情報キャッシュをクリアする
    external.setCouponStatus("");
    couponStatusCache = "";
    log("clear couponStatusCache");

    // 変更数カウンタをクリア
    $('#update span[class^="ui-li-count"]').remove();
    //$("#update").trigger("create");
    changedItemCount = 0;

    // arrayCouponSwitchの値を更新する
    for ( var i = 0, len = arrayTelno.length ; i < len; i++) {
      arrayCouponSwitch[i] = $("#couponSwitch" + i).val();
      arrayCouponSwitchCurrent[i] = arrayCouponSwitch[i];
    }

    // ローディング・メッセージを非表示
    $.mobile.hidePageLoadingMsg();

    // ロック解除
    setLock(false);

    // navbarが描画されないことがあるので、少し遅れてinvalidateをかける
    setTimeout(function(){
      log("setCouponStatusResultHandler: calling invalidateView");
      external.invalidateView();
    }, 500);


  }

  // setLock拡張
  function setLock(status) {
    log("calling setLock");
    locked = status;
  }

  $(document).ready(function() {

    // navbarが描画されないことがあるので、少し遅れてinvalidateをかける。1000msだとすっぽぬける
    setTimeout(function(){
      log("ready: calling invalidateView");
      external.invalidateView();
    }, 2000);

  });

  // メインページ初期化(1回だけ呼ばれる)
  // readyより前に呼ばれる
  $(document).on("pageinit", "#mainPage", function(event) {

    // 最初に呼ばれる
    $.mobile.loadingMessageTextVisible = true;
    $.mobile.loadingMessage = "ロード中です";
    $.mobile.loadingMessageTheme = "a";

    // スイッチを隠す
    $("#inner-content").hide();

    // 端末に格納されたトークンを取得
    token = external.getToken();
    log("#mainPage pageinit token=" + token);

    // 端末に格納されたクーポン情報キャッシュを取得
    couponStatusCache = external.getCouponStatus();
    log("#mainPage pageinit couponStatusCache=" + couponStatusCache);

    // 端末に格納されたstateを取得
    state = external.getState();
    log("#mainPage pageinit state=" + state);

    // フリップスイッチ操作イベント
    $('#telnoList').on('change', 'li', function () {

      var index = arrayIndex[$(this).index()];
      log("this.index=" + $(this).index() + " arrayIndex=" + index);

      // ON/OFFが変更されているか確認
      var currentValue = $("#couponSwitch" + index).val();
      log("currentValue=" + currentValue);
      log("index=" + index);
      log("arrayCouponSwitch=" + arrayCouponSwitch[index]);
      log("arrayCouponSwitchCurrent=" + arrayCouponSwitchCurrent[index]);

      // ON/OFFの変更がなければret
      if (currentValue == arrayCouponSwitchCurrent[index]) {
        return;
      }

      arrayCouponSwitchCurrent[index] = currentValue;

      if (currentValue != arrayCouponSwitch[index]) {
        // 変更した
        changedItemCount++;
        log("changed: " + index);
      } else {
        // 戻した
        changedItemCount--;
        log("unchanged: " + index);
      }

      if (changedItemCount > 0) {
        $('#update span[class^="ui-li-count"]').remove();
        $("#update").append('<span class="ui-li-count">' + changedItemCount + '</span>');
      } else {
        $('#update span[class^="ui-li-count"]').remove();
      }

      // navbarが描画されないことがあるので、少し遅れてinvalidateをかける
      setTimeout(function(){
        log("changed: calling invalidateView");
        external.invalidateView();
      }, 500);


    });

    $('#telnoList').on('tap', 'li', function () {
      log("tap!");

      if (taphold) {
        log("taphold = true, exit.");
        //taphold = false;
        return;
      }

      log("this.index=" + $(this).index());

      var index = arrayIndex[$(this).index()];
      log("this=" + $("#caption" + index).text());

      var divUsage = $("#usage" + index);
      var iconUsage = $("#iconUsage" + index);

      log("focus=" + $(':focus').attr('id'));
      $(divUsage).toggle();

      if ($(iconUsage).hasClass("ui-icon-arrow-r")) {
        $(iconUsage).removeClass("ui-icon-arrow-r");
        $(iconUsage).addClass("ui-icon-arrow-d");
      } else {
        $(iconUsage).removeClass("ui-icon-arrow-d");
        $(iconUsage).addClass("ui-icon-arrow-r");
      }

    });

    // 変更ボタンの処理
    $("#update").click(function() {

      if (arrayTelno.length == 0) {
        $(this).removeClass("ui-btn-hover-a");
        $(this).removeClass("ui-btn-down-a");
        $(this).removeClass("ui-btn-active");
        $(this).addClass("ui-btn-up-a");
        // エラー画面を表示
        external.showDialog("情報がありません", "更新ボタンを押して最新の情報を取得してください。");
        return;
      }

      if (changedItemCount == 0) {
        // 変更がない
        $(this).removeClass("ui-btn-hover-a");
        $(this).removeClass("ui-btn-down-a");
        $(this).removeClass("ui-btn-active");
        $(this).addClass("ui-btn-up-a");
        // エラー画面を表示
        external.showDialog("変更されていません", "クーポンのON/OFFは変更されていません");
        return;
      }

      // JSONをポストする
      setCouponStatus();

      // hoverがたまに残るので除去
      $(this).removeClass("ui-btn-hover-a");
      $(this).removeClass("ui-btn-down-a");
      $(this).removeClass("ui-btn-active");
      $(this).addClass("ui-btn-up-a");

    });

    // 更新ボタンの処理
    $("#refresh").click(function() {

      // クーポン情報取得
      getCouponStatus(false);

      // hoverがたまに残るので除去
      $(this).removeClass("ui-btn-hover-a");
      $(this).removeClass("ui-btn-down-a");
      $(this).removeClass("ui-btn-active");
      $(this).addClass("ui-btn-up-a");

    });

    // メイン画面から設定画面に遷移する
    $("#gear").click(function() {

      // ロックを解除する
      setLock(false);

      // 設定画面に遷移する
      $.mobile.changePage("#settings", {
        transition : transition
      });

    });

    $("#update").touchend(function() {
      $(this).removeClass("ui-btn-hover-a");
      $(this).addClass("ui-btn-up-a")
    });

    $("#update").touchmove(function() {
      $(this).removeClass("ui-btn-hover-a");
      $(this).addClass("ui-btn-up-a")
    });

    $("#update").touchstart(function() {
      $(this).removeClass("ui-btn-up-a")
      $(this).addClass("ui-btn-hover-a");
    });

    // clickが発火しなかった場合に備えて
    $("#refresh").touchend(function() {
      $(this).removeClass("ui-btn-hover-a");
      $(this).addClass("ui-btn-up-a")
    });

    // Android 4.0はtouchendが呼ばれない？
    $("#refresh").touchmove(function() {
      $(this).removeClass("ui-btn-hover-a");
      $(this).addClass("ui-btn-up-a")
    });

    $("#refresh").touchstart(function() {
      $(this).removeClass("ui-btn-up-a")
      $(this).addClass("ui-btn-hover-a");
    });

    $("#gear").touchend(function() {
      $(this).removeClass("ui-btn-hover-a");
      $(this).addClass("ui-btn-up-a")
    });

    $("#gear").touchmove(function() {
      $(this).removeClass("ui-btn-hover-a");
      $(this).addClass("ui-btn-up-a")
    });

    $("#gear").touchstart(function() {
      $(this).removeClass("ui-btn-up-a")
      $(this).addClass("ui-btn-hover-a");
    });

  });

  // メインページが表示される度に呼ばれる
  $(document).on('pageshow', "#mainPage", function(event, ui) {

    log("#mainPage pageshow token=" + token);

    // アプリでないならここでQueryStringを処理する
    // URLにアクセストークンがあるなら取得し、再表示をかけてURLを消す
    if (!isApp) {

      var url = window.location.hash.substring(1);
      var accessToken = getQueryStringParam(url, 'access_token');
      var receivedState = getQueryStringParam(url, 'state');

      log("receivedState: " + receivedState);

      // CSRF対策でstateをチェックする
      if ((accessToken != "") && (state == receivedState)) {

        // トークン更新
        token = accessToken;

        // 端末にも格納する
        external.setToken(token);

        log("#mainPage pageshow redirect callback");
        window.location.replace(redirectUrl);
        
        // 処理を打ち切る
        return;
      }

    }

    // tokenが空またはundefinedならログイン画面に遷移する
    if ((token == null) || (token == "") || (token == "undefined")) {

      var salt = CryptoJS.lib.WordArray.random(128/8);
      log("#mainPage pageshow salt=" + salt);

      // state更新   
      state = CryptoJS.PBKDF2("Secret Passphrase", salt, { keySize: 256/32 });

      // 端末にも格納する
      external.setState(state);

      // 認証エンドポイントにリダイレクト
      log("#mainPage pageshow redirect loginDialog");

      // Androidの場合は標準ブラウザ開く
      if ((isApp) && (!isIos)) {
        external.openDefaultBrowser(authEndPoint + "?response_type=token&client_id=" + clientId + "&state=" + state + "&redirect_uri=" + encodeURIComponent(redirectUrl));
      } else {
        window.location.replace(authEndPoint + "?response_type=token&client_id=" + clientId + "&state=" + state + "&redirect_uri=" + encodeURIComponent(redirectUrl));
      }
      
      return;

    }

    log("#mainPage pageshow doOnce=" + doOnce);

    // couponStatusが空またはundefinedならサーバから取得する
    if (doOnce) {

      doOnce = false;

      // クーポン情報取得(キャッシュがあれば使う)
      getCouponStatus(true);

    }

    // hoverを外す。少し遅らせる
    setTimeout(function(){
      $("#update").removeClass("ui-btn-hover-a");
      $("#refresh").removeClass("ui-btn-hover-a");
      $("#update").addClass("ui-btn-up-a");
      $("#refresh").addClass("ui-btn-up-a");
    }, 200);

  });

  // 設定画面
  $(document).on('pageinit', "#settings", function(event) {

    // キャッシュのクリア
    $("#clear").click(function() {

      // 端末のトークンをクリアする
      token = "";
      external.setToken(token);

      // クーポン情報キャッシュをクリアする
      external.setCouponStatus("");
      couponStatusCache = "";

      $(this).removeClass("ui-btn-active");

      external.showDialogDefault("保存情報のクリア", "保存情報を削除しました。");

    });

    $("#clear").touchend(function() {
      $(this).removeClass("ui-btn-active");
    });

    $("#clear").touchstart(function() {
      $(this).addClass("ui-btn-active");
    });

    $("#backFromSettings").touchend(function() {
      $(this).removeClass("ui-btn-active");
    });

    $("#backFromSettings").touchstart(function() {
      $(this).addClass("ui-btn-active");
    });

    // 設定画面からメイン画面に遷移する
    $("#backFromSettings").click(function() {

    });

  });

  // 設定画面が表示される度に呼ばれる
  $(document).on('pageshow', "#settings", function(event, ui) {

    log("#settings pageShow");

    // mainPageに戻るバックボタン
    //external.setPageFlag(1);

  });

  // 設定画面からの遷移後に呼ばれる
  $(document).on('pagehide', "#settings", function(event, ui) {

    log("#settings pagehide nextpage=" + ui.nextPage.attr('id'));

    if (ui.nextPage.attr('id') == "mainPage") { 

      // バックボタン制御しない
      //external.setPageFlag(0);

    } else {

      // settingsに戻るバックボタン
      //external.setPageFlag(2);

    }

  });

  $(document).on('pageinit', "#errorDialog", function(event) {

    $("#backFromErrorDialog").touchend(function() {
      $(this).removeClass("ui-btn-active");
    });

    $("#backFromErrorDialog").touchstart(function() {
      $(this).addClass("ui-btn-active");
    });

  });

  $(document).on('pageshow', "#errorDialog", function(event, ui) {

    // 背景を半透明にする
    ui.prevPage.addClass("ui-dialog-background");

    // ローディング・メッセージを非表示
    $.mobile.hidePageLoadingMsg();

    $("#errorTitle").text(errTitle);
    $("#errorMessage").text(errMsg);

    // ダイアログのセンタリング
    var height = parseInt($("#errorDialog").css("height"), 10) / 2;
    var dialogHeight = parseInt($("#errorDialog").find('.ui-dialog-contain').css("height"), 10) / 2;
    var paddingTop = parseInt(height - dialogHeight);
    $("#errorDialog").find('.ui-dialog-contain').css("margin-top", 0);
    $("#errorDialog").find('.ui-dialog-contain').css("top", 0);
    $("#errorDialog").css("padding-top", Math.max(0, paddingTop) + "px");

  });

  $(document).on('pagehide', "#errorDialog", function(event, ui) {
    $(".ui-dialog-background").removeClass("ui-dialog-background");
  });

  // ワークアラウンド
  $(document).on('pageinit', "#errorDialogWorkAround", function(event) {

    $("#backFromErrorDialogWorkAround").touchend(function() {
      $(this).removeClass("ui-btn-active");
    });

    $("#backFromErrorDialogWorkAround").touchstart(function() {
      $(this).addClass("ui-btn-active");
    });
    log("#errorDialogWorkAround pageinit");

  });

  $(document).on('pageshow', "#errorDialogWorkAround", function(event, ui) {

    // 背景を半透明にする
    ui.prevPage.addClass("ui-dialog-background");

    // ローディング・メッセージを非表示
    $.mobile.hidePageLoadingMsg();

    $("#errorTitleWorkAround").text(errTitle);
    $("#errorMessageWorkAround").text(errMsg);

    // ダイアログのセンタリング
    var height = parseInt($("#errorDialogWorkAround").css("height"), 10) / 2;
    var dialogHeight = parseInt($("#errorDialogWorkAround").find('.ui-dialog-contain').css("height"), 10) / 2;
    var paddingTop = parseInt(height - dialogHeight);
    $("#errorDialogWorkAround").find('.ui-dialog-contain').css("margin-top", 0);
    $("#errorDialogWorkAround").find('.ui-dialog-contain').css("top", 0);
    $("#errorDialogWorkAround").css("padding-top", Math.max(0, paddingTop) + "px");

    log("#errorDialogWorkAround pageshow");

  });

  $(document).on('pagehide', "#errorDialogWorkAround", function(event, ui) {
    $(".ui-dialog-background").removeClass("ui-dialog-background");
    log("#errorDialogWorkAround pagehide");
  });

  $( window ).on("orientationchange", function(event) {
    // navbarが描画されないことがあるので、少し遅れてinvalidateをかける
    setTimeout(function(){
      log("orientationchange: calling invalidateView");
      external.invalidateView();
    }, 500);
  });

